#####################################################################
#
# 
#

all: .depend $(ALL)

depend:
	$(CC) -M *.c* $(CCFLAGS) >.depend

.depend:
	$(CC) -M *.c* $(CCFLAGS) >.depend
	$(MAKE)

clean:
	(for N in $(ALL); do rm -f $$N $${N}.o $${N}_d $${N}_static; done)
	rm -f .depend
	rm -f core
	rm -f gmon.out gmon.sum

ifeq (.depend,$(wildcard .depend))
include .depend
endif

% : %.o
ifeq ($(USESHAREDLIB),y)
	$(CC) $< -o $@ $(LDFLAGS) $(LIBS) -lXclasses $(CCFLAGS)
else
	$(CC) $< -o $@ $(TOPDIR)/lib/$(ARNAME) $(LDFLAGS) $(LIBS) $(CCFLAGS)
endif
	$(STRIP) $@ &

%_static : %.o
ifeq ($(USESHAREDLIB),y)
	$(CC) $< -o $@ $(TOPDIR)/lib/$(ARNAME) $(LDFLAGS) $(LIBS) $(CCFLAGS)
endif
	$(STRIP) $@ &

%.o: %.c
	$(CC) -c $< $(CCFLAGS) 

%.o: %.cpp
	$(CC) -c $< $(CCFLAGS) 
