#ifndef INCL_XCLASSESCLASS_H
#define INCL_XCLASSESCLASS_H

// *-----------------------------------------------------------------------
// * Xclasses class header file
// * 
// * class name: Xclasses
// * author    : Jrgen Schmitz
// * version   : 1.0
// *-----------------------------------------------------------------------

#include <Xclasses/types.h>

class Xclasses
{
	friend class pXclasses;
	class pXclasses *p;
public:
	void *classdata;	// free for your own use

    Xclasses();
    Xclasses(char *name);
    virtual ~Xclasses();

	void Name(char *n);
	char *Name(void);
	char *FullName(void);
	void ParentClass(Xclasses *);
	void ParentClass(Xclasses &o) { ParentClass(&o); };
	Xclasses *ParentClass(void);
	int IsClassType(char *);
	Xclasses *ParentClassType(char *);

	char *GetResource(char *);
	void SetResource(char *,char *);

	static Xclasses *ScanObjects(char *basename,Xclasses *old);
};

class Xclasses *FindObject(char *name);
class Xclasses *FindObject(char *base,char *name);
inline class Xclasses *FindObject(class Xclasses *base,char *name)
{ return FindObject(base->FullName(),name); }
void DeleteObjectTree(char *base,int flags=0);
char *TranslateName(char *name);		// manipulates (name)!

#define DOT_NOTBASE		0x00000001	// don't delete named base object

#endif
