#ifndef INCL_CARD_H
#define INCL_CARD_H

// *-----------------------------------------------------------------------
// * Xclasses class header file
// * 
// * class name: card
// * author    : Jrgen Schmitz
// * version   : 1.0
// *-----------------------------------------------------------------------

#include <Xclasses/types.h>
#include <Xclasses/gadget.h>
#include <Xclasses/group.h>
#include <Xclasses/Xcolors.h>
#include <Xclasses/Ddraw.h>

class card : Ddraw, public gadget 
{
	friend class pcard;

	class pcard *p;

public:
    virtual void GExpose(XEvent *event);
    virtual void GActionPress(int mx,int my,int rx,int ry,unsigned int state,int button,int reason);
    virtual void GActionRelease(int mx,int my,int rx,int ry,unsigned int state,int button,int reason);
	virtual void GSetLimits(void);
	virtual int GActivate(XEvent *event,int why);
	virtual int GSelected(XEvent *event,int why,int wasabove);

public:
    card();
    virtual ~card();

    virtual int Create(void);
    virtual void Free(void);
    virtual void Resize(int nw,int nh);
    virtual void Lock(void);
    virtual void Unlock(void);
    virtual void Block(int);
    virtual void Unblock(int);

	void Add(char *,group *);
	void Add(char *n,group &g) { Add(n,&g); };

	void Selected(int);
	int Selected(void);
};

#endif
