#ifndef INCL_FILEDIALOG_H
#define INCL_FILEDIALOG_H

// *-----------------------------------------------------------------------
// * Xclasses class header file
// * 
// * class name: file_dialog
// * author    : Jrgen Schmitz
// * version   : 1.0
// *-----------------------------------------------------------------------

#include <Xclasses/types.h>
#include <Xclasses/Xwindows.h>
#include <Xclasses/Xcolors.h>
#include <Xclasses/group.h>


class file_dialog : public Xcolors
{
	friend class pfile_dialog;
	
	class pfile_dialog *p;

public:
    file_dialog(void);
    virtual ~file_dialog();

	void Text_Ok(char *);
	void Text_Cancel(char *);

	void InsertGroup(group *);
	void InsertGroup(group &g) { InsertGroup(&g); };

	void SaveMode(void);
	void LoadMode(void);
	void ShowPeriod(void);
	void NoPeriod(void);

	void MultiSelect(void);
	void SingleSelect(void);

	void SetDir(char *);
	void GetDir(char *,int size);
	void SetFile(char *);
	void GetFile(char *,int size);
	void SetPattern(char *);
	int IsSelectedMarked(void);
	int NextMarkedFile(int,char *,int size);	

	int Start(Xwindows *w);
	int Start(Xwindows &w) { return Start(&w); };
};

#endif
