#ifndef INCL_GFXOBJECT_H
#define INCL_GFXOBJECT_H

// *-----------------------------------------------------------------------
// * Xclasses class header file
// * 
// * class name: gfx_object
// * author    : Jrgen Schmitz
// * version   : 1.0
// *-----------------------------------------------------------------------

#include <Xclasses/types.h>
#include <Xclasses/Xcolors.h>

#define ADJUST_LEFT		0
#define ADJUST_CENTER	1
#define ADJUST_RIGHT	2
        
#define ADJUST_TOP		0
#define ADJUST_MIDDLE	4
#define ADJUST_BOTTOM	8

#define NOLIMIT			-1

class gfx_object : public Xcolors
{
public:
	gfx_object(void);
	virtual ~gfx_object();

	virtual void Adjust(int);

	virtual void draw_normal(class gadget *g,int x,int y,int w,int h);
	virtual void draw_selected(class gadget *g,int x,int y,int w,int h);
	virtual void draw_locked(class gadget *g,int x,int y,int w,int h);
	virtual void draw_selectedlocked(class gadget *g,int x,int y,int w,int h);

	virtual int height(class gadget *g);	// NOLIMIT if scalable
	virtual int width(class gadget *g);		// NOLIMIT if scalable
};

// all do nothing and return NOLIMIT


#endif
