#ifndef INCL_GFXTEXT_H
#define INCL_GFXTEXT_H

// *-----------------------------------------------------------------------
// * Xclasses class header file
// * 
// * class name: gfx_text
// * author    : Jrgen Schmitz
// * version   : 1.0
// *-----------------------------------------------------------------------

#include <Xclasses/types.h>
#include <Xclasses/gfx_object.h>

class gfx_text : public gfx_object
{
	friend class pgfx_text;
	class pgfx_text *p;
public:

	gfx_text(void);
	gfx_text(char *);
	virtual ~gfx_text();
	
	virtual void Adjust(int);

	virtual void draw_normal(class gadget *g,int x,int y,int w,int h);
	virtual void draw_selected(class gadget *g,int x,int y,int w,int h);
	virtual void draw_locked(class gadget *g,int x,int y,int w,int h);
	virtual void draw_selectedlocked(class gadget *g,int x,int y,int w,int h);

	virtual int height(class gadget *g);
	virtual int width(class gadget *g);

	void Text(char *);
	void NoUnderlineText(char *txt);	// ignores underline as ShortCut mark
	char ShortCut(void);
	static char ShortCut(char *);
};

#endif
