#ifndef INCL_GOBUTTON_H
#define INCL_GOBUTTON_H

// *-----------------------------------------------------------------------
// * Xclasses class header file
// * 
// * class name: go_button
// * author    : Jrgen Schmitz
// * version   : 1.0
// *-----------------------------------------------------------------------

#include <Xclasses/types.h>
#include <Xclasses/gadget.h>
#include <Xclasses/Xcolors.h>
#include <Xclasses/Ddraw.h>
#include <Xclasses/gfx_object.h>

class go_button : Ddraw, public gadget 
{
	friend class pgo_button;

	class pgo_button *p;

public:
    virtual void GExpose(XEvent *event);
    virtual void GActionPress(int mx,int my,int rx,int ry,unsigned int state,int button,int reason);
    virtual void GActionRelease(int mx,int my,int rx,int ry,unsigned int state,int button,int reason);
	virtual void GSetLimits(void);
	virtual int GActivate(XEvent *event,int why);
	virtual int GSelected(XEvent *event,int why,int wasabove);

public:
    go_button();
    virtual ~go_button();

    virtual int Create(void);
    void Object(gfx_object *obj);
    void Object(gfx_object &obj) { Object(&obj); }
    
    void UseLimit(void);
    void NoLimit(void);				// default
    void UseLocked(void);
    void NotUseLocked(void);		// default
    void UseBorder(void);			// default
    void NoBorder(void);
    void NoKeyBorder(void);
	void SendTicks(void);
	void NoTicks(void);				// default
	void Aspect(int minx,int miny,int maxx,int maxy);
};

#endif
