#ifndef INCL_GOSELBUTTON_H
#define INCL_GOSELBUTTON_H

// *-----------------------------------------------------------------------
// * Xclasses class header file
// * 
// * class name: go_selbutton
// * author    : Jrgen Schmitz
// * version   : 1.0a
// *-----------------------------------------------------------------------

#include <Xclasses/types.h>
#include <Xclasses/selgadget.h>
#include <Xclasses/Ddraw.h>
#include <Xclasses/Xcolors.h>
#include <Xclasses/gfx_object.h>

class go_selbutton : Ddraw, public selgadget
{
	friend class pgo_selbutton;

	class pgo_selbutton *p;

public:
    virtual void GExpose(XEvent *event);
    virtual void GActionPress(int mx,int my,int rx,int ry,unsigned int state,int button,int reason);
    virtual void GActionRelease(int mx,int my,int rx,int ry,unsigned int state,int button,int reason);
	virtual void GSetLimits(void);
	virtual int GActivate(XEvent *event,int why);
	virtual int GSelected(XEvent *event,int why,int wasabove);
	
public:
    go_selbutton();
    virtual ~go_selbutton();

    int Create(void);
    void Object(gfx_object *);
    void Object(gfx_object &obj) { Object(&obj); }
    
    void UseLimit(void);
    void NoLimit(void);				// default
    void UseLocked(void);
    void NotUseLocked(void);		// default
    void UseBorder(void);			// default
    void NoBorder(void);
    void NoKeyBorder(void);
	void Aspect(int minx,int miny,int maxx,int maxy);

	virtual void State(int st);
	virtual int  State(void);
};

#endif
