#ifndef INCL_GRAPHIC_H
#define INCL_GRAPHIC_H

// *-----------------------------------------------------------------------
// * Xclasses class header file
// * 
// * class name: graphic
// * author    : Jrgen Schmitz
// * version   : 1.0
// *-----------------------------------------------------------------------

#include <time.h>
#include <Xclasses/types.h>
#include <Xclasses/gadget.h>
#include <Xclasses/Xcolors.h>
#include <Xclasses/Ddraw.h>


class graphic : Ddraw, public gadget
{
	friend class pgraphic;
	
	class pgraphic *p;

public:
    virtual void GExpose(XEvent *event);
    virtual void GActionPress(int mx,int my,int rx,int ry,unsigned int state,int button,int reason);
    virtual void GActionRelease(int mx,int my,int rx,int ry,unsigned int state,int button,int reason);
    virtual int GActivate(XEvent *event,int why);
    virtual int GSelected(XEvent *event,int why,int wasabove);
    virtual void GSetLimits(void);

public:
	graphic();
    virtual ~graphic();

    virtual int Create(void);
    void Free(void);
	
	void Size(int w,int h);
	Pixmap pixmap(void);
	GC gc(void);

	void Draw(void);

	int FontHeight(void);
	int FontAscent(void);
	void Clear(void);
	void Foreground(int);
	void Line(int,int,int,int);
	void DrawString(int x,int y,char *);
	int StringLength(char *);
	void FillRectangle(int x,int y,int w,int h);
};

#endif
