#ifndef INCL_IMAGE_H
#define INCL_IMAGE_H

// *-----------------------------------------------------------------------
// * Xclasses class header file
// * 
// * class name: image
// * author    : Jrgen Schmitz
// * version   : 1.0
// *-----------------------------------------------------------------------

#include <Xclasses/types.h>
#include <Xclasses/gadget.h>
#include <Xclasses/Xcolors.h>
#include <Xclasses/Ddraw.h>
#include <Xclasses/gfx_object.h>


class image : Ddraw, public gadget
{
	friend class pimage;
	
	class pimage *p;

public:
    virtual void GExpose(XEvent *event);
    virtual void GSetLimits(void);

public:
	image();
    virtual ~image();

    virtual int Create(void);
    void Free(void);

	void Object(class gfx_object *);
	void Object(class gfx_object &g) { Object(&g); };
	
	void Border(void);		// default
	void NoBorder(void); 
};

#endif
