#ifndef INCL_INDICATOR_H
#define INCL_INDICATOR_H

// *-----------------------------------------------------------------------
// * Xclasses class header file
// * 
// * class name: indicator
// * author    : Jrgen Schmitz
// * version   : 1.0
// *-----------------------------------------------------------------------

#include <Xclasses/types.h>
#include <Xclasses/gadget.h>
#include <Xclasses/Xcolors.h>
#include <Xclasses/Ddraw.h>


class indicator : Ddraw, public gadget 
{
	friend class pindicator;
	
	class pindicator *p;

public:
    virtual void GExpose(XEvent *event);
	virtual int GActivate(XEvent *event,int why) { return 0; };
	virtual void GSetLimits(void);

public:
    indicator(void);
    virtual ~indicator();

	void Title(char *t);
	void VertIndicator(void);	// currently unsupported
	void HorizIndicator(void);	// default
	void CircleIndicator(void);

    int Create(void);

	void MaxValue(int v);
	void MaxValue(int v,int smark);

	void Value(int v);
	void Value(int v,char *t);	// value and text
	void Text(char *t);
};

#endif
