#ifndef INCL_INPUT_H
#define INCL_INPUT_H

// *-----------------------------------------------------------------------
// * Xclasses class header file
// * 
// * class name: input
// * author    : Jrgen Schmitz
// * version   : 1.0
// *-----------------------------------------------------------------------

#include <Xclasses/types.h>
#include <Xclasses/gadget.h>
#include <Xclasses/Xcolors.h>
#include <Xclasses/Ddraw.h>

class input : Ddraw, public gadget 
{
	friend class pinput;

	class pinput *p;

public:
    virtual void GExpose(XEvent *event);
    virtual void GActionPress(int mx,int my,int rx,int ry,unsigned int state,int button,int reason);
    virtual void GActionRelease(int mx,int my,int rx,int ry,unsigned int state,int button,int reason);
    virtual int  GMouseMove(int mx,int my,int rx,int ry,unsigned int state,int button);
    virtual int  GActivate(XEvent *event,int why);
    virtual int  GSelected(XEvent *event,int why,int wasabove);
	virtual int  GClipHandler(int why,char *data,int size);
	virtual void GSetLimits(void);

public:
    input();
    virtual ~input();

    virtual int Create(void);
    virtual void Free(void);
	virtual void Resize(int w,int h);
	virtual void Lock(void);
	virtual void Unlock(void);
	virtual void Block(int);
	virtual void Unblock(int);

    int MaxChars(int m);
    void Text(char *t);
    void AlwaysMode(void);
	void IntegerMode(void);
	void InvisibleMode(void);

    void Default(char *t);
	void Input(char *t);
	void Cursor(int c);
	int Cursor(void);
};

#endif
