#ifndef INCL_LISTGROUP_H
#define INCL_LISTGROUP_H

// *-----------------------------------------------------------------------
// * Xclasses class header file
// * 
// * class name: listgroup
// * author    : Jrgen Schmitz
// * version   : 1.0
// *-----------------------------------------------------------------------

#include <Xclasses/types.h>
#include <Xclasses/gadget.h>
#include <Xclasses/group.h>
#include <Xclasses/Xcolors.h>

class listgroup : public gadget 
{
	friend class plistgroup;

	class plistgroup *p;

public:
	virtual void GSetLimits(void);
	virtual int GSelected(XEvent *event,int why,int wasabove);

public:
    listgroup();
    virtual ~listgroup();

    virtual int Create(void);
    virtual void Free(void);
    virtual void Resize(int nw,int nh);
    virtual void Lock(void);
    virtual void Unlock(void);
    virtual void Block(int);
    virtual void Unblock(int);

	void Add(char *,group *);
	void Add(char *n,group &g) { Add(n,&g); };

	void Selected(int);
	int Selected(void);
};

#endif
