#ifndef INCL_MESSAGE_H
#define INCL_MESSAGE_H

// *-----------------------------------------------------------------------
// * Xclasses class header file
// * 
// * class name: message
// * author    : Jrgen Schmitz
// * version   : 1.0
// *-----------------------------------------------------------------------

#include <Xclasses/types.h>
#include <Xclasses/gadget.h>
#include <Xclasses/dlist.h>

class message
{
	dlist	gadgets;
public:

	message();
	virtual ~message();

	virtual void Msg(gadget *,int t);

	void Add(gadget *,class msg_get *,class msg_conv *,class msg_set *,class msg_conv *);
	void Add(gadget &g,class msg_get *m1,class msg_conv *m2,class msg_set *m3,class msg_conv *m4)
			{ Add(&g,m1,m2,m3,m4); };
	void Remove(class gadget *);
	void Remove(class gadget &g) { Remove(&g); };

	void Set(void *);
	void Set(int v) { Set((void*)&v); };
	void Set(char *v) { Set((void*)v); };

	void *Get(void);
};

// -------------------------------------------------------------------
// abstract classes

class msg_get
{
protected:
	void *classptr;
	void (*classfunc)(void);
public:
	msg_get(void *classptr,void (*)(void));
	virtual ~msg_get();

	virtual void *get(void) =0;
};
class msg_set
{
protected:
	void *classptr;
	void (*classfunc)(void);
public:
	msg_set(void *classptr,void (*)(void));
	virtual ~msg_set();

	virtual void set(void *) =0;
};
class msg_conv
{
public:
	msg_conv();
	virtual ~msg_conv();

	virtual void *conv(void*) =0;
};

#define MSG_CHANGE		1
#define MSG_FINAL		2

#define MSGCAST		(void (*)(void))

#endif
