#ifndef INCL_MESSAGETOOLS_H
#define INCL_MESSAGETOOLS_H

// *-----------------------------------------------------------------------
// * Xclasses class header file
// * 
// * filename  : message_tools
// * author    : Jrgen Schmitz
// * version   : 1.0
// *-----------------------------------------------------------------------

#include <Xclasses/message.h>

// ===================================================================
// msg get classes
// -------------------------------------------------------------------

class msgget_int : public msg_get
{

public:
	msgget_int(void *classptr,void (*)(void));
	virtual ~msgget_int();

	virtual void *get(void);
};
class msgget_char : public msg_get
{
	char *buf;
public:
	msgget_char(void *classptr,void (*)(void),int size=64);
	virtual ~msgget_char();

	virtual void *get(void);
};


// ===================================================================
// msg set classes
// -------------------------------------------------------------------

class msgset_int : public msg_set
{

public:
	msgset_int(void *classptr,void (*)(void));
	virtual ~msgset_int();

	virtual void set(void *);
};
class msgset_char : public msg_set
{

public:
	msgset_char(void *classptr,void (*)(void));
	virtual ~msgset_char();

	virtual void set(void *);
};


// ===================================================================
// msg conv classes
// -------------------------------------------------------------------

class msgconv_int2char : public msg_conv
{
	char *buf;
public:
	msgconv_int2char();
	virtual ~msgconv_int2char();

	virtual void *conv(void*);
};
class msgconv_char2int : public msg_conv
{
public:
	msgconv_char2int();
	virtual ~msgconv_char2int();

	virtual void *conv(void*);
};


#endif
