#ifndef INCL_RUBBERGROUP_H
#define INCL_RUBBERGROUP_H

// *-----------------------------------------------------------------------
// * Xclasses class header file
// * 
// * class name: rubbergroup
// * author    : Jrgen Schmitz
// * version   : 1.0
// *-----------------------------------------------------------------------

#include <Xclasses/types.h>
#include <Xclasses/gadget.h>
#include <Xclasses/Ddraw.h>

class rubbergroup : Ddraw, public gadget 
{
	friend class prubbergroup;

	class prubbergroup *p;

public:
	virtual void GExpose(XEvent *);
	virtual int  GActivate(XEvent *event,int why);
	virtual int  GSelected(XEvent *event,int why,int wasabove);
	virtual int  GMouseMove(int mx,int my,int rx,int ry,unsigned int state,int button);
	virtual void GActionPress(int mx,int my,int rx,int ry,unsigned int state,int button,int reason);
	virtual void GActionRelease(int mx,int my,int rx,int ry,unsigned int state,int button,int reason);

    virtual void GSetLimits(void);	// SetSize

	rubbergroup(void);
	virtual ~rubbergroup(void);

	void Add(class gadget *gd);
	void Add(class gadget &gd) { Add(&gd); };

	virtual int Create(void);
    virtual void Free(void);
    virtual void Resize(int width,int height);

	virtual void Lock(void);
	virtual void Unlock(void);
    virtual void Block(int);
    virtual void Unblock(int);

	void Horiz(void);
	void Vert(void);		// Default
};

#endif
