#ifndef INCL_SCROLLER_H
#define INCL_SCROLLER_H

// *-----------------------------------------------------------------------
// * Xclasses class header file
// * 
// * class name: scroller
// * author    : Jrgen Schmitz
// * version   : 1.0
// *-----------------------------------------------------------------------

#include <Xclasses/types.h>
#include <Xclasses/gadget.h>
#include <Xclasses/Xcolors.h>
#include <Xclasses/Ddraw.h>

class scroller : Ddraw, public gadget 
{
	friend class pscroller;

	class pscroller *p;

public:
    virtual void GExpose(XEvent *event);
    virtual void GActionPress(int mx,int my,int rx,int ry,unsigned int state,int button,int reason);
    virtual void GActionRelease(int mx,int my,int rx,int ry,unsigned int state,int button,int reason);
    virtual int  GMouseMove(int mx,int my,int rx,int ry,unsigned int state,int button);
    virtual int  GActivate(XEvent *event,int why);
    virtual int  GSelected(XEvent *event,int why,int wasabove);
	virtual void GSetLimits(void);

public:
    scroller();
    virtual ~scroller();

    int Create(void);
    void Free(void);
	void Resize(int w,int h);
	void Lock(void);
	void Unlock(void);
    void Block(int);
    void Unblock(int);

	void Vert(void);
	void Horiz(void);
	void Arrows(void);
    
    void Items(int);
    void Visible(int);
    void Position(int);
    int Position(void);
};

#endif
