#ifndef INCL_SLIDER_H
#define INCL_SLIDER_H

// *-----------------------------------------------------------------------
// * Xclasses class header file
// * 
// * class name: slider
// * author    : Jrgen Schmitz
// * version   : 1.0
// *-----------------------------------------------------------------------

#include <Xclasses/types.h>
#include <Xclasses/gadget.h>
#include <Xclasses/Xcolors.h>
#include <Xclasses/Ddraw.h>

class slider : Ddraw, public gadget 
{
	friend class pslider;

	class pslider *p;

public:
    virtual void GExpose(XEvent *event);
    virtual void GActionPress(int mx,int my,int rx,int ry,unsigned int state,int button,int reason);
    virtual void GActionRelease(int mx,int my,int rx,int ry,unsigned int state,int button,int reason);
    virtual int  GMouseMove(int mx,int my,int rx,int ry,unsigned int state,int button);
    virtual int  GActivate(XEvent *event,int why);
    virtual int  GSelected(XEvent *event,int why,int wasabove);
	virtual void GSetLimits(void);

public:
    slider();
    virtual ~slider();

    virtual int Create(void);

	void Vert(void);
	void Horiz(void);
    
    void MinValue(int);
    void MaxValue(int);
    void Value(int);
    int Value(void);
    
    void TextCallback(void cfunc(int val,char *buf,int maxsize));
    void TextCallback(void *cl,...);
};

#endif
