#ifndef INCL_TYPES_H
#define INCL_TYPES_H

// *-----------------------------------------------------------------------
// * Xclasses class header file
// * 
// * common include file
// * author    : Jrgen Schmitz
// * version   : 1.0
// *-----------------------------------------------------------------------

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/cursorfont.h>
#include <stdio.h>
#include <unistd.h>
#include <math.h>

#include <Xclasses/Xclasses_class.h>


// State for selgadgets
#define PRESSED		1
#define RELEASED	0

// use this for casting class hooks (like listview::SetHook)
// usage: e.g. Hook(&myclass,(CLASSHOOKCAST)&myclass.function);
#define CLASSHOOKCAST void (*)(...)

// use this for casting gadget callbacks
// usage: e.g. Callback(&myclass,(CALLBACKCAST)&myclass.function);
#define CALLBACKCAST void (*)(gadget*,int)

// creates class with name
#define NEW(classname,objectname)	classname objectname; objectname.Name("objectname");

#endif
