#ifndef INCL_VISIBLE_H
#define INCL_VISIBLE_H

// *-----------------------------------------------------------------------
// * Xclasses class header file
// * 
// * class name: visible
// * author    : Jrgen Schmitz
// * version   : 1.0
// *-----------------------------------------------------------------------

#include <Xclasses/types.h>
#include <Xclasses/gadget.h>
#include <Xclasses/Xcolors.h>
#include <Xclasses/Ddraw.h>

class visible : Ddraw, public gadget 
{
	friend class pvisible;

	class pvisible *p;

public:
    virtual void GExpose(XEvent *event);
    virtual void GActionPress(int mx,int my,int rx,int ry,unsigned int state,int button,int reason);
    virtual void GActionRelease(int mx,int my,int rx,int ry,unsigned int state,int button,int reason);
	virtual void GSetLimits(void);
	virtual int GMouseMove(int mx,int my,int rx,int ry,unsigned int state,int button);
	virtual int GActivate(XEvent *event,int why);
	virtual int GSelected(XEvent *event,int why,int wasabove);

public:
    visible();
    virtual ~visible();

    virtual int Create(void);
    virtual void Free(void);
    virtual void Resize(int nw,int nh);
    virtual void Lock(void);
    virtual void Unlock(void);
    virtual void Block(int);
    virtual void Unblock(int);

	void Apply(class gadget *);
	void Apply(class gadget &);
	void Zoom(int z=2);
};

#endif
