#ifndef INCL_XCLOCK_H
#define INCL_XCLOCK_H

// *-----------------------------------------------------------------------
// * Xclasses class header file
// * 
// * class name: xclock
// * author    : Jrgen Schmitz
// * version   : 1.0
// *-----------------------------------------------------------------------

#include <time.h>
#include <Xclasses/types.h>
#include <Xclasses/gadget.h>
#include <Xclasses/Xcolors.h>
#include <Xclasses/Ddraw.h>


class xclock : Ddraw, public gadget
{
	friend class pxclock;
	
	class pxclock *p;

public:
    virtual void GExpose(XEvent *event);
    virtual void GActionPress(int mx,int my,int rx,int ry,unsigned int state,int button,int reason);
    virtual void GActionRelease(int mx,int my,int rx,int ry,unsigned int state,int button,int reason);
    virtual int GActivate(XEvent *event,int why);
    virtual int GSelected(XEvent *event,int why,int wasabove);
    virtual void GSetLimits(void);

public:
    xclock();
    virtual ~xclock();

    virtual int Create(void);
    
    void Seconds(void);
    void NoSeconds(void);	// default
    void ExactMinutes(void);
    void NiceMinutes(void);	// default
    void SmallSeconds(void);
    void LongSeconds(void);	// default
	void NoMinutes(void);
	void Minutes(void);		// default
    
    void FormCircel(void);	// default
    void FormCrazy(void);
};

#endif
